// GraphicsContent.cpp : implementation file
//

#include "stdafx.h"
#include "tulsa sample app.h"
#include "GraphicsContentDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGraphicsContentDlg dialog


CGraphicsContentDlg::CGraphicsContentDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGraphicsContentDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGraphicsContentDlg)
	m_Filename = _T("");
	m_AlphaValue = 0;
	//}}AFX_DATA_INIT
}


void CGraphicsContentDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGraphicsContentDlg)
	DDX_Control(pDX, IDC_LIST_ALPHA_PATTERNS, m_AlphaPatternList);
	DDX_Text(pDX, IDC_FILENAME, m_Filename);
	DDX_Text(pDX, IDC_ALPHA_VALUE, m_AlphaValue);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CGraphicsContentDlg, CDialog)
	//{{AFX_MSG_MAP(CGraphicsContentDlg)
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGraphicsContentDlg message handlers

void CGraphicsContentDlg::OnBrowse() 
{
	CFileDialog FileDlg(TRUE, 
						NULL, 
						NULL, 
						OFN_FILEMUSTEXIST, 
						"Bitmap Files (*.bmp)|*.bmp| All Files (*.*)|*.*||");

    strcpy(FileDlg.m_ofn.lpstrFile, m_Content.m_Filename);

	char szDrive[_MAX_DRIVE];
	char szDir[_MAX_DIR];
	char szInitPath[_MAX_PATH];
	_splitpath(m_Content.m_Filename, szDrive, szDir, NULL, NULL);
	sprintf(szInitPath, "%s%s", szDrive, szDir);
	FileDlg.m_ofn.lpstrInitialDir = szInitPath;
	FileDlg.m_ofn.lpstrTitle = "Select Bitmap";

	if (FileDlg.DoModal() != IDOK) {
		return;
	}

	m_Filename = FileDlg.GetPathName();
	strcpy(m_Content.m_Filename, m_Filename);
	
	UpdateData(FALSE);
}

BOOL CGraphicsContentDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	m_Filename = m_Content.m_Filename;
	m_AlphaValue = m_Content.m_StartingAlpha;

	switch(m_Content.m_Source) {
	case SRC_GENERATE:
		CheckRadioButton(IDC_SRC_TEST_PATTERN, IDC_SRC_FILE, IDC_SRC_TEST_PATTERN);
		break;
	case SRC_BMP_FILE:
	default:
		CheckRadioButton(IDC_SRC_TEST_PATTERN, IDC_SRC_FILE, IDC_SRC_FILE);
		break;
	}

	switch(m_Content.m_AlphaSource) {
	case ALPHA_SRC_GENERATE:
		CheckRadioButton(IDC_ALPHA_FILE, IDC_ALPHA_GENERATE, IDC_ALPHA_GENERATE);
		break;
	case ALPHA_SRC_BMP_FILE:
	default:
		CheckRadioButton(IDC_ALPHA_FILE, IDC_ALPHA_GENERATE, IDC_ALPHA_FILE);
		break;
	}

	switch(m_Content.m_AlphaEffect) {
	case ALPHA_EFFECT_LTOR:
	case ALPHA_EFFECT_RTOL:
		m_AlphaPatternList.SetCurSel(m_Content.m_AlphaEffect);
		break;

	case ALPHA_EFFECT_NONE:
	default:
		m_AlphaPatternList.SetCurSel(0);
		break;
	}

	UpdateData(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CGraphicsContentDlg::OnOK() 
{
	UpdateData(TRUE);
	m_Content.m_StartingAlpha = m_AlphaValue;

	switch(GetCheckedRadioButton(IDC_SRC_TEST_PATTERN, IDC_SRC_FILE)) {
	case IDC_SRC_TEST_PATTERN:
		m_Content.m_Source = SRC_GENERATE;
		break;
	case IDC_SRC_FILE:
	default:
		m_Content.m_Source = SRC_BMP_FILE;
		break;
	}
		
	switch(GetCheckedRadioButton(IDC_ALPHA_FILE, IDC_ALPHA_GENERATE)) {
	case IDC_ALPHA_GENERATE:		
	default:
		m_Content.m_AlphaSource = ALPHA_SRC_GENERATE;
		break;
	case IDC_ALPHA_FILE:
		m_Content.m_AlphaSource = ALPHA_SRC_BMP_FILE;
		break;
	}

	m_Content.m_AlphaEffect = (ALPHA_EFFECT)m_AlphaPatternList.GetCurSel();
	
	CDialog::OnOK();
}
